%global commit dad6419bcfc6ecd2c866b44f55c74a8548028c76
%global snapdate 20231101

Name:           cr-marcstevens-snippets
%global snapinfo ^%{snapdate}git%(echo '%{commit}' | cut -b -7)
Version:        0%{snapinfo}
Release:    1%{?dist}
Summary:        Collection of useful one-file C/C++ headers

License:        MIT AND BSL-1.0
URL:            https://github.com/cr-marcstevens/snippets
Source0:        %{url}/archive/%{commit}/snippets-%{commit}.tar.gz
Source1:        https://www.boost.org/LICENSE_1_0.txt

Patch0:          %{url}/pull/2.patch
Patch1:          %{url}/pull/4.patch

BuildRequires:  gcc-c++

%global debug_package %{nil}

%description
%{summary}.


%package base64-devel
Summary:        A header only C++ base64 encoder/decoder library
License:        MIT

BuildArch:      noarch

Provides:       %{name}-base64-static = %{version}-%{release}

%description base64-devel
%{summary}.


%package concurrent_unordered_map-devel
Summary:        A header only C++ light-weight concurrent unordered map
License:        MIT

BuildArch:      noarch

Provides:       %{name}-concurrent_unordered_map-static = %{version}-%{release}

%description concurrent_unordered_map-devel
%{summary}.


%package cpuperformance-devel
Summary:        A header only C++ light-weight aids for CPU cycle counting
License:        MIT

BuildArch:      noarch

Provides:       %{name}-cpuperformance-static = %{version}-%{release}

%description cpuperformance-devel
%{summary}.


%package parallel_algorithms-devel
Summary:        A header only C++ light-weight parallel algorithms library
License:        MIT

BuildArch:      noarch

Provides:       %{name}-parallel_algorithms-static = %{version}-%{release}

%description parallel_algorithms-devel
%{summary}.


%package program_options-devel
Summary:        A header only C++ C++ boost-like program options class
License:        MIT

BuildArch:      noarch

Provides:       %{name}-program_options-static = %{version}-%{release}

%description program_options-devel
%{summary}.


%package progress_display-devel
Summary:        Extension from boost::progress_display
License:        BSL-1.0

BuildArch:      noarch

Provides:       %{name}-progress_display-static = %{version}-%{release}

%description progress_display-devel
%{summary}.


%package string_algo-devel
Summary:        A header only C++ string algorithms
License:        MIT

BuildArch:      noarch

Provides:       %{name}-string_algo-static = %{version}-%{release}

%description string_algo-devel
%{summary}.


%package thread_pool-devel
Summary:        A header only C++ light-weight thread pool
License:        MIT

BuildArch:      noarch

Provides:       %{name}-thread_pool-static = %{version}-%{release}

%description thread_pool-devel
%{summary}.


%prep
%autosetup -n snippets-%{commit} -p1
rm -rvf autoconf
cp -p '%{SOURCE1}' .


%build
%set_build_flags
mkdir -p _test '%{_vpath_builddir}'
for hdr in cxxheaderonly/*.hpp
do
  lib="$(basename "${hdr}" '.hpp')"
  cat > "_test/${lib}.cpp" <<EOF
int main(int, char *[]) { return 0; }
EOF
  "${CXX:-g++}" -I"${PWD}/cxxheaderonly" "_test/${lib}.cpp" \
      -o "%{_vpath_builddir}/${lib}" ${CXXFLAGS} ${LDFLAGS}
done


%install
install -t '%{buildroot}%{_includedir}/cr-marcstevens' \
    -p -m 0644 -D cxxheaderonly/*.hpp




%files base64-devel
%license LICENSE
%dir %{_includedir}/cr-marcstevens
%{_includedir}/cr-marcstevens/base64.hpp


%files concurrent_unordered_map-devel
%license LICENSE
%dir %{_includedir}/cr-marcstevens
%{_includedir}/cr-marcstevens/concurrent_unordered_map.hpp


%files cpuperformance-devel
%license LICENSE
%dir %{_includedir}/cr-marcstevens
%{_includedir}/cr-marcstevens/cpuperformance.hpp


%files parallel_algorithms-devel
%license LICENSE
%dir %{_includedir}/cr-marcstevens
%{_includedir}/cr-marcstevens/parallel_algorithms.hpp


%files program_options-devel
%license LICENSE
%dir %{_includedir}/cr-marcstevens
%{_includedir}/cr-marcstevens/program_options.hpp


%files progress_display-devel
%license LICENSE_1_0.txt
%dir %{_includedir}/cr-marcstevens
%{_includedir}/cr-marcstevens/progress_display.hpp


%files string_algo-devel
%license LICENSE
%dir %{_includedir}/cr-marcstevens
%{_includedir}/cr-marcstevens/string_algo.hpp


%files thread_pool-devel
%license LICENSE
%dir %{_includedir}/cr-marcstevens
%{_includedir}/cr-marcstevens/thread_pool.hpp


%changelog
* Fri Apr 12 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0%{snapinfo}-1
- initial build
